--------------------------------------------------------------------------------
---- Baixa de Dades per el test del sistema ------------------------------------
--------------------------------------------------------------------------------

DECLARE

RSP VARCHAR2(200);
CURSOR C0 IS SELECT cens, votacio FROM ASSIGNACIO 
			 WHERE votacio IN (SELECT titol FROM VOTACIO WHERE estat = 'Edici') ORDER BY cens DESC;
CURSOR C00 IS SELECT nom FROM CENS WHERE nom NOT IN (SELECT cens FROM ASSIGNACIO) ORDER BY nom DESC;
CURSOR C1 IS SELECT codi FROM CIUTADA WHERE n_vot_part = 0 ORDER BY codi;
CURSOR C2 IS SELECT ciutada, cens 
			 FROM INSCRIPCIO 
			 WHERE ciutada IN (SELECT codi FROM CIUTADA
							   WHERE n_vot_part = 0) ORDER BY ciutada;
CURSOR C3 IS SELECT codi FROM OPCIO WHERE votacio IN (SELECT titol FROM VOTACIO WHERE estat = 'Edici');
v1 VARCHAR2(50);
v2 VARCHAR2(50);
v3 VARCHAR2(50);
dn DATE;
num NUMBER;
id1 NUMBER;

BEGIN

--------------------------------------------------------------------------------
------ Donem de baixa alguna Assignaci de Cens a Votaci ----------------------
--------------------------------------------------------------------------------
  --- Obrim el cursor d'Assignacions
  num := 0;
  OPEN C0;
  LOOP
     --- Fem un recorregut per totes elles
    FETCH C0 INTO v1, v2;
    --- Si no hi han ms dades sortim
    EXIT WHEN C0%NOTFOUND OR num = 2;
      BAIXA_ASSIGNACIO(v1, v2, RSP);
      num := num + 1;
  END LOOP;
  --- Tanquem el cursor
  CLOSE C0;
  
  --- Validem totes les transaccions.
  COMMIT;
  
--------------------------------------------------------------------------------
---- Donem de baixa alguns dels Censos del sistema -----------------------------
--------------------------------------------------------------------------------  
  --- Obrim el cursor de Censos
  num := 0;
  OPEN C00;
  LOOP
     --- Fem un recorregut per tots ells
    FETCH C00 INTO v1;
    --- Si no hi han ms dades sortim
    EXIT WHEN C00%NOTFOUND OR num = 5;
    BAIXA_CENS(v1, RSP);
    num := num + 1;
  END LOOP;
  --- Tanquem el cursor
  CLOSE C00;
  
--------------------------------------------------------------------------------
---- Donem de baixa alguns Ciutadans amb les seves Inscripcions ----------------
--------------------------------------------------------------------------------  
  --- Obrim el cursor de Ciutadans
  num := 0;
  OPEN C1;
  LOOP
     --- Fem un recorregut per tots ells
    FETCH C1 INTO v1;
    --- Si no hi han ms dades sortim
    EXIT WHEN C1%NOTFOUND OR num = 10;
    BAIXA_CIUTADA(v1, RSP);
    num := num + 1;
  END LOOP;
  --- Tanquem el cursor
  CLOSE C1;
  
--------------------------------------------------------------------------------
---- Donem de baixa algunes inscripcions dels Ciutadans als seus Censos --------
--------------------------------------------------------------------------------  
  --- Obrim el cursor de Ciutadans
  num := 0;
  OPEN C2;
  LOOP
     --- Fem un recorregut per tots ells
    FETCH C2 INTO id1, v1;
    --- Si no hi han ms dades sortim
    EXIT WHEN C2%NOTFOUND OR num = 12;
    BAIXA_INSCRIPCIO(id1, v1, RSP);
    num := num + 1;
  END LOOP;
  --- Tanquem el cursor
  CLOSE C2;
  
--------------------------------------------------------------------------------
-------- Esborrem vries Opcions -----------------------------------------------
--------------------------------------------------------------------------------  
  --- Obrim el cursor d'Opcions de Vot
  num := 0;
  OPEN C3;
  LOOP
     --- Fem un recorregut per tots ells
    FETCH C3 INTO id1;
    --- Si no hi han ms dades sortim
    EXIT WHEN C3%NOTFOUND OR num = 3;
      BAIXA_OPCIO(id1, RSP);
	  num := num + 1;
  END LOOP;
  --- Tanquem el cursor
  CLOSE C3;
    
--------------------------------------------------------------------------------
-------- Esborrem 2 Votacions amb les seves Opcions i Assignacions --------
--------------------------------------------------------------------------------
  --- Seleccionem una Votaci en Edici
  SELECT titol INTO v1 FROM (SELECT titol FROM VOTACIO 
                       WHERE estat IN('Edici') AND titol NOT IN('Obertura Atlantica') ORDER BY titol ASC)
  WHERE ROWNUM = 1;
  --- Esborrem la Votaci resultant
      BAIXA_VOTACIO(v1, RSP);
	
  --- Seleccionem una Votaci Pendent
  SELECT titol INTO v1 FROM (SELECT titol FROM VOTACIO 
                       WHERE estat IN('Pendent'))
  WHERE ROWNUM = 1;
  --- Esborrem la Votaci resultant
      BAIXA_VOTACIO(v1, RSP);
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/