--------------------------------------------------------------------------------
---- Proves amb errors per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

DECLARE

RSP VARCHAR2(200);
v VARCHAR2(50);
n NUMBER;
d DATE;
v1 VARCHAR2(50);
v2 VARCHAR2(50);
v3 VARCHAR2(50);
v4 VARCHAR2(50);
d1 DATE;
n1 NUMBER;
n2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
------- ALTA_ASSIGNACIO() ------------------------------------------------------
--------------------------------------------------------------------------------
  --- Valors buits
  ALTA_ASSIGNACIO(v, 'Constitucio Europea', d, RSP);
  ALTA_ASSIGNACIO('Reg_PT_LIS', v, d, RSP);
  
  --- Valors inexistents
  ALTA_ASSIGNACIO('Reg_ES_CAT', 'x', d, RSP);
  ALTA_ASSIGNACIO('x', 'Constitucio Europea', d, RSP);
  
  --- Valors repetits 
  ALTA_ASSIGNACIO('Europa', 'Sortir Euro', '10/05/2009', RSP);
  
  --- Valors no permesos
  ALTA_ASSIGNACIO('Reg_ES_CAT', 'Constitucio Europea', d, RSP);
  
  
--------------------------------------------------------------------------------
------- ALTA_CENS() ------------------------------------------------------------
--------------------------------------------------------------------------------  
  --- Valors buits
  ALTA_CENS(v, v, v, v, RSP);
  ALTA_CENS('Estatal', v, v, v, RSP);
  ALTA_CENS('Regional', v, v, v, RSP);
  ALTA_CENS('Local', v, v, v, RSP);
  
  --- Valors inexistents
  ALTA_CENS('Estatal', 'x', v, v, RSP);
  ALTA_CENS('Regional', v, 'x', v, RSP);
  ALTA_CENS('Local', v, v, 'x', RSP);
  
  --- Valors repetits
  ALTA_CENS('Global', v1, v1, v1, RSP);
  ALTA_CENS('Estatal', 'ES', v, v, RSP);
  ALTA_CENS('Regional', v, 'ES_CAT', v, RSP);
  ALTA_CENS('Local', v, v, 'ES_CAT_PREM', RSP);
  
  --- Valors no permesos
  ALTA_CENS('x', v1, v1, v1, RSP);
  
--------------------------------------------------------------------------------
------- ALTA_CIUTADA() ---------------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  ALTA_CIUTADA(d, v, v, v, RSP);
  ALTA_CIUTADA('03/02/1968', v, v, v, RSP);
  ALTA_CIUTADA('03/02/1968', 'ES_CAT_PRED', v, v, RSP);
  ALTA_CIUTADA('03/02/1968', 'ES_CAT_PRED', 'ES_CAT', v, RSP);
  ALTA_CIUTADA('03/02/1968', 'ES_CAT_PRED', v, 'ES', RSP);
  ALTA_CIUTADA('03/02/1968', v, 'ES_CAT', 'ES', RSP);
  
  --- Valors inexistents
  ALTA_CIUTADA('03/02/1968', 'ES_CAT_PRED', 'ES_CAT', 'x', RSP);
  ALTA_CIUTADA('03/02/1968', 'ES_CAT_PRED', 'x', 'ES', RSP);
  ALTA_CIUTADA('03/02/1968', 'x', 'ES_CAT', 'ES', RSP);
  
  --- Valors no permesos
  ALTA_CIUTADA('03/02/2000', 'ES_CAT_PRED', 'ES_CAT', 'ES', RSP);
  
--------------------------------------------------------------------------------
------- ALTA_INSCRIPCIO() ------------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  ALTA_INSCRIPCIO(n1, d, RSP);
  
  --- Valors inexistents
  ALTA_INSCRIPCIO(-1, d, RSP);
  --- Esbrinem si ja existeix
  SELECT COUNT (codi)INTO n1 FROM LOCALITAT WHERE codi IN('ES_CAT_TEIA');
  IF n1 = 0 THEN
    INSERT INTO LOCALITAT VALUES('ES_CAT_TEIA', 'ES_CAT', 'ES', 'Tei'); --- Insertem una Localitat nova
    ALTA_CIUTADA('03/02/1960', 'ES_CAT_TEIA', 'ES_CAT', 'ES', RSP); --- Donem d'alta un Ciutad a aquesta Localitat
  END IF;
  
  SELECT codi INTO n1 --- Seleccionem aquest nou Ciutad
  FROM (SELECT codi FROM CIUTADA WHERE localitat NOT IN (SELECT localitat FROM CENS_LOCAL)) 
  WHERE ROWNUM = 1; 
  ALTA_INSCRIPCIO(n1, d, RSP); --- Fem una inscripci amb el Ciutad: Error de Cens inexistent
  
  --- Valors repetits
  --- Noms es far la inscripci si el Ciutad no s inscrit, d'aquesta forma ens estalviem el procediment MODIFICAR_INSCRIPCIO().
  
--------------------------------------------------------------------------------
------- ALTA_OPCIO() -----------------------------------------------------------
-------------------------------------------------------------------------------- 
  SELECT titol INTO v1 
  FROM (SELECT titol FROM VOTACIO WHERE estat = 'Edici' AND titol IN (SELECT votacio FROM OPCIO)) 
  WHERE ROWNUM = 1;
  SELECT descripcio INTO v2 
  FROM (SELECT descripcio FROM OPCIO WHERE votacio = v1) 
  WHERE ROWNUM = 1;
  --- Valors buits
  ALTA_OPCIO(v, v, RSP);
  ALTA_OPCIO(v1, v, RSP);
  
  --- Valors inexistents
  ALTA_OPCIO('x', v, RSP);
  
  --- Valors repetits
  ALTA_OPCIO(v1, v2, RSP);
  
  --- Valors no permesos
  SELECT titol INTO v1 FROM (SELECT titol FROM VOTACIO WHERE estat = 'Pendent') WHERE ROWNUM = 1;
  ALTA_OPCIO(v1, 'No es permet', RSP);
  SELECT titol INTO v1 FROM (SELECT titol FROM VOTACIO WHERE estat = 'Oberta') WHERE ROWNUM = 1;
  ALTA_OPCIO(v1, 'No es permet', RSP);
  SELECT titol INTO v1 FROM (SELECT titol FROM VOTACIO WHERE estat = 'Tancada') WHERE ROWNUM = 1;
  ALTA_OPCIO(v1, 'No es permet', RSP);
  
--------------------------------------------------------------------------------
------- ALTA_VOTACIO() ---------------------------------------------------------
-------------------------------------------------------------------------------- 
  d1 := '10/10/2010';
  --- Valors buits
  ALTA_VOTACIO(v, d, d, d, v, v, v, RSP);
  ALTA_VOTACIO('x', d1, d1+7, d1+9, v, v, v, RSP);
  ALTA_VOTACIO('x', d1, d1+7, d1+9, 'JP', v, v, RSP);
  
  --- Valors inexistents
  /* No afecta */
  
  --- Valors repetits  
  ALTA_VOTACIO('Constitucio Europea', d1, d1+7, d1+9, 'a', 'b', v, RSP);
  
  --- Valors no permesos
  ALTA_VOTACIO('x', d1, d1+6, d1+9, 'a', 'b', v, RSP);
  ALTA_VOTACIO('x', d1, d1+7, d1+6, 'a', 'b', v, RSP);
  
--------------------------------------------------------------------------------
------- BAIXA_ASSIGNACIO() -----------------------------------------------------
--------------------------------------------------------------------------------
  --- Valors buits
  BAIXA_ASSIGNACIO('x', v, RSP);
  BAIXA_ASSIGNACIO(v, 'x', RSP);
  --- Valors inexistents
  BAIXA_ASSIGNACIO('x', 'y', RSP);
  --- Valors repetits
  /* Si repetim un valor, la segona vegada sortir l'error de valor inexistent.*/
  --- Valors no permesos
  SELECT votacio INTO v1
  FROM (SELECT votacio 
		FROM ASSIGNACIO 
		WHERE votacio IN (SELECT titol 
						  FROM VOTACIO 
						  WHERE estat IN( 'Pendent', 'Oberta', 'Tancada')))
  WHERE ROWNUM = 1;
  SELECT cens INTO v2 FROM (SELECT cens FROM ASSIGNACIO WHERE votacio = v1)
  WHERE ROWNUM = 1;
  BAIXA_ASSIGNACIO('v2', 'v1', RSP);
  
--------------------------------------------------------------------------------
------- BAIXA_CENS() -----------------------------------------------------------
--------------------------------------------------------------------------------  
  --- Valors buits
  BAIXA_CENS(v, RSP);
  --- Valors inexistents
  BAIXA_CENS('x', RSP);
  --- Valors repetits
  /* Si repetim un valor, la segona vegada sortir l'error de valor inexistent.*/
  --- Valors no permesos
  SELECT cens INTO v1 FROM ASSIGNACIO WHERE ROWNUM = 1;
  BAIXA_CENS(v1, RSP);
  
--------------------------------------------------------------------------------
------- BAIXA_CIUTADA() --------------------------------------------------------
--------------------------------------------------------------------------------
  --- Valors buits
  BAIXA_CIUTADA(n, RSP);
  --- Valors inexistents
  BAIXA_CIUTADA(-1, RSP);
  --- Valors repetits
  /* Si repetim un valor, la segona vegada sortir l'error de valor inexistent.*/
  --- Valors no permesos
  SELECT ciutada INTO n1 FROM VOT WHERE ROWNUM = 1;
  BAIXA_CIUTADA(n1, RSP);
  
--------------------------------------------------------------------------------
------- BAIXA_INSCRIPCIO() -----------------------------------------------------
--------------------------------------------------------------------------------
  --- Valors buits
  BAIXA_INSCRIPCIO(n, v, RSP);
  BAIXA_INSCRIPCIO(0, v, RSP);
  --- Valors inexistents
  BAIXA_INSCRIPCIO(0, 'x', RSP);
  --- Valors repetits
  /* Si repetim un valor, la segona vegada sortir l'error de valor inexistent.*/
  --- Valors no permesos
  /* Qualsevol Ciutad pot donar-se de baixa d'un Cens en qualsevol moment */
  
--------------------------------------------------------------------------------
------- BAIXA_OPCIO() ----------------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  BAIXA_OPCIO(n, RSP);
  --- Valors inexistents
  BAIXA_OPCIO(0, RSP);
  --- Valors repetits
  /* Si repetim un valor, la segona vegada sortir l'error de valor inexistent.*/
  --- Valors no permesos
  SELECT codi INTO n1 
  FROM (SELECT codi 
		FROM OPCIO 
		WHERE votacio IN (SELECT titol 
						  FROM VOTACIO 
						  WHERE estat IN ('Pendent', 'Oberta', 'Tancada')))
  WHERE ROWNUM = 1;
  BAIXA_OPCIO(n1, RSP);
  
--------------------------------------------------------------------------------
------- BAIXA_VOTACIO() --------------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  BAIXA_VOTACIO(v, RSP);
  --- Valors inexistents
  BAIXA_VOTACIO('x', RSP);
  --- Valors repetits
  /* Si repetim un valor, la segona vegada sortir l'error de valor inexistent.*/
  --- Valors no permesos
  SELECT titol INTO v1
  FROM (SELECT titol FROM VOTACIO WHERE estat IN('Oberta', 'Tancada'))
  WHERE ROWNUM = 1;
  BAIXA_VOTACIO(v1, RSP);
  
--------------------------------------------------------------------------------
------- MODIFICAR_CIUTADA() ----------------------------------------------------
--------------------------------------------------------------------------------
  --- Valors buits
  MODIFICAR_CIUTADA(n, d, v, v, v, RSP);
  --- Valors inexistents
  SELECT codi INTO n1 FROM CIUTADA WHERE ROWNUM = 1;
  MODIFICAR_CIUTADA(-1, d, v, v, v, RSP);
  MODIFICAR_CIUTADA(-1, d, 'x', 'y', 'z', RSP);
  --- Valors repetits
  /* Si els valors sn repetits no hi haur cap modificaci efectiva. */
  --- Valors no permesos  
  MODIFICAR_CIUTADA(n1, SYSDATE, v, v, v, RSP); --- Menor d'edat
  
--------------------------------------------------------------------------------
------- MODIFICAR_VOTACIO() ----------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  MODIFICAR_VOTACIO(v, d, d, d, v, v, v, RSP);
  --- Valors inexistents
  MODIFICAR_VOTACIO('x', d, d, d, v, v, v, RSP);
  --- Valors repetits
  /* Si els valors sn repetits no hi haur cap modificaci efectiva. */
  --- Valors no permesos
  SELECT titol INTO v1
  FROM (SELECT titol FROM VOTACIO WHERE estat IN('Oberta', 'Pendent', 'Tancada'))
  WHERE ROWNUM = 1;
  MODIFICAR_VOTACIO(v1, d, d, d, v, v, v, RSP);
  
  SELECT titol, data_publicacio INTO v1, d1
  FROM (SELECT titol, data_publicacio FROM VOTACIO WHERE estat IN('Edici'))
  WHERE ROWNUM = 1;
  MODIFICAR_VOTACIO(v1, d, d1+3, d, v, v, v, RSP);
  MODIFICAR_VOTACIO(v1, d, d1+8, d1, v, v, v, RSP);
  
--------------------------------------------------------------------------------
------- MODIFICAR_ESTAT_VOTACIO() ----------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  MODIFICAR_ESTAT_VOTACIO(v, v, RSP);
  MODIFICAR_ESTAT_VOTACIO('x', v, RSP);
  --- Valors inexistents
  MODIFICAR_ESTAT_VOTACIO('x', 'y', RSP);
  --- Valors repetits
  /* Si els valors sn repetits no hi haur cap modificaci efectiva. */
  --- Valors no permesos
  SELECT titol INTO v1 
  FROM (SELECT titol FROM VOTACIO WHERE estat = 'Tancada') 
  WHERE ROWNUM = 1;
  MODIFICAR_ESTAT_VOTACIO(v1, 'x', RSP);
  SELECT titol INTO v1 
  FROM (SELECT titol FROM VOTACIO WHERE estat = 'Edici' ORDER BY titol DESC) 
  WHERE ROWNUM = 1;
  MODIFICAR_ESTAT_VOTACIO(v1, 'x', RSP);
  MODIFICAR_ESTAT_VOTACIO(v1, 'Oberta', RSP);
  
  SELECT votacio INTO v1
  FROM(SELECT votacio, COUNT(votacio) AS vot
       FROM OPCIO
       GROUP BY votacio ORDER BY vot)
  WHERE ROWNUM = 1;
  MODIFICAR_ESTAT_VOTACIO(v1, 'Pendent', RSP);
  
  SELECT titol INTO v1 
  FROM (SELECT titol FROM VOTACIO WHERE titol NOT IN(SELECT votacio FROM ASSIGNACIO)) 
  WHERE ROWNUM = 1;
  MODIFICAR_ESTAT_VOTACIO(v1, 'Tancada', RSP);
  
--------------------------------------------------------------------------------
------- MODIFICAR_OPCIO() ------------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  MODIFICAR_OPCIO(n, v, RSP);
  MODIFICAR_OPCIO(0, v, RSP);
  --- Valors inexistents
  MODIFICAR_OPCIO(0, 'x', RSP);
  --- Valors repetits
  /* Si els valors sn repetits no hi haur cap modificaci efectiva. */
  --- Valors no permesos
  SELECT codi INTO n1
  FROM (SELECT codi 
		FROM OPCIO 
		WHERE votacio IN (SELECT titol 
						  FROM VOTACIO 
						  WHERE estat IN ('Oberta', 'Pendent', 'Tancada')))
  WHERE ROWNUM = 1;
  MODIFICAR_OPCIO(n1, 'x', RSP);
	
--------------------------------------------------------------------------------
------- LLISTAT() --------------------------------------------------------------
-------------------------------------------------------------------------------- 
  --- Valors buits
  LLISTAT(v, v, n, RSP);
  LLISTAT('a', v, n, RSP);
  LLISTAT('d', v, n, RSP);
  
  --- Valors inexistents
  LLISTAT('a', 'x', n, RSP);
  LLISTAT('d', v, 0, RSP);
  
  --- Valors no permesos
  LLISTAT('x', v, n, RSP);
  
--------------------------------------------------------------------------------
------- VOTAR() ----------------------------------------------------------------
-------------------------------------------------------------------------------- 
  SELECT titol INTO v1 
  FROM (SELECT titol FROM VOTACIO WHERE estat = 'Oberta')
  WHERE ROWNUM = 1;
  
  SELECT data_obertura INTO d1 FROM VOTACIO WHERE titol = v1;
  
  SELECT ciutada INTO n1 
  FROM (SELECT ciutada 
		FROM INSCRIPCIO 
		WHERE ciutada NOT IN(SELECT ciutada FROM VOT WHERE votacio = v1) 
          AND 
          cens IN(SELECT cens FROM ASSIGNACIO WHERE votacio = v1))
  WHERE ROWNUM = 1;
  
  SELECT codi INTO n2 FROM (SELECT codi FROM OPCIO WHERE votacio = v1) 
  WHERE ROWNUM = 1;
  --- Valors buits
  VOTAR(v, n, n, d, RSP);
  VOTAR(v1, n, n2, d1+1, RSP);
  VOTAR(v1, n1, n, d1+1, RSP);
  
  --- Valors inexistents
  VOTAR('x', n, n, d, RSP);
  VOTAR(v1, 0, n2, d1+1, RSP);
  VOTAR(v1, n1, 0, d1+1, RSP);
  
  --- Valors repetits  
  VOTAR(v1, n1, n2+1, d1+1, RSP);
  VOTAR(v1, n1, n2, d1+1, RSP);  --- Vot duplicat
  
  --- Valors no permesos
  VOTAR(v1, n1, n2, d1-1, RSP); --- Data fora de termini
  SELECT titol INTO v1 
  FROM (SELECT titol FROM VOTACIO WHERE estat = 'Pendent' ORDER BY titol DESC)
  WHERE ROWNUM = 1;
  SELECT data_obertura INTO d1 FROM VOTACIO WHERE titol = v1;
  SELECT ciutada INTO n1 
  FROM (SELECT ciutada 
        FROM INSCRIPCIO 
        WHERE cens IN(SELECT cens 
                      FROM ASSIGNACIO 
                      WHERE votacio = v1))
  WHERE ROWNUM = 1;
  SELECT codi INTO n2 FROM (SELECT codi FROM OPCIO WHERE votacio = v1) 
  WHERE ROWNUM = 1;
  VOTAR(v1, n1, n2, d1+1, RSP); --- Votaci no Oberta
  
  SELECT codi INTO n1
  FROM (SELECT codi 
        FROM CIUTADA 
        WHERE codi NOT IN(SELECT ciutada FROM INSCRIPCIO))
  WHERE ROWNUM = 1;
  
  ALTA_INSCRIPCIO(n1, d, RSP); --- Inscripci amb data d'avui
  SELECT titol INTO v1 
  FROM (SELECT titol 
        FROM VOTACIO 
        WHERE estat = 'Oberta' AND titol IN (SELECT VOTACIO FROM ASSIGNACIO WHERE cens = 'Europa'))
  WHERE ROWNUM = 1;
  SELECT data_obertura INTO d1 FROM VOTACIO WHERE titol = v1;
  SELECT codi INTO n2 FROM (SELECT codi FROM OPCIO WHERE votacio = v1) 
  WHERE ROWNUM = 1;
  VOTAR(v1, n1, n2, d1+1, RSP); --- La Inscripci s fora de termini
  
  
END;
/